/*
 * Copyright (c) 2016, The Linux Foundation. All rights reserved.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 and only version 2 as published by the Free Software
 * Foundation. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details. 
 */

#ifndef _SOC_FC__IOCTOP
#define _SOC_FC__IOCTOP

#define _IOC_TOP_MODULE_BASE                     0x10e40000

#define rSW_TOP_FUNC_SEL_0_REG_SET                (*(volatile unsigned *) 0x10E40080U)
#define rSW_TOP_FUNC_SEL_0_REG_CLR                (*(volatile unsigned *) 0x10E40084U)
#define rSW_TOP_FUNC_SEL_1_REG_SET                (*(volatile unsigned *) 0x10E40088U)
#define rSW_TOP_FUNC_SEL_1_REG_CLR                (*(volatile unsigned *) 0x10E4008CU)
#define rSW_TOP_FUNC_SEL_2_REG_SET                (*(volatile unsigned *) 0x10E40090U)
#define rSW_TOP_FUNC_SEL_2_REG_CLR                (*(volatile unsigned *) 0x10E40094U)
#define rSW_TOP_FUNC_SEL_3_REG_SET                (*(volatile unsigned *) 0x10E40098U)
#define rSW_TOP_FUNC_SEL_3_REG_CLR                (*(volatile unsigned *) 0x10E4009CU)
#define rSW_TOP_FUNC_SEL_4_REG_SET                (*(volatile unsigned *) 0x10E400A0U)
#define rSW_TOP_FUNC_SEL_4_REG_CLR                (*(volatile unsigned *) 0x10E400A4U)
#define rSW_TOP_FUNC_SEL_5_REG_SET                (*(volatile unsigned *) 0x10E400A8U)
#define rSW_TOP_FUNC_SEL_5_REG_CLR                (*(volatile unsigned *) 0x10E400ACU)
#define rSW_TOP_FUNC_SEL_6_REG_SET                (*(volatile unsigned *) 0x10E400B0U)
#define rSW_TOP_FUNC_SEL_6_REG_CLR                (*(volatile unsigned *) 0x10E400B4U)
#define rSW_TOP_FUNC_SEL_7_REG_SET                (*(volatile unsigned *) 0x10E400B8U)
#define rSW_TOP_FUNC_SEL_7_REG_CLR                (*(volatile unsigned *) 0x10E400BCU)
#define rSW_TOP_FUNC_SEL_8_REG_SET                (*(volatile unsigned *) 0x10E400C0U)
#define rSW_TOP_FUNC_SEL_8_REG_CLR                (*(volatile unsigned *) 0x10E400C4U)
#define rSW_TOP_FUNC_SEL_9_REG_SET                (*(volatile unsigned *) 0x10E400C8U)
#define rSW_TOP_FUNC_SEL_9_REG_CLR                (*(volatile unsigned *) 0x10E400CCU)
#define rSW_TOP_FUNC_SEL_10_REG_SET               (*(volatile unsigned *) 0x10E400D0U)
#define rSW_TOP_FUNC_SEL_10_REG_CLR               (*(volatile unsigned *) 0x10E400D4U)
#define rSW_TOP_FUNC_SEL_11_REG_SET               (*(volatile unsigned *) 0x10E400D8U)
#define rSW_TOP_FUNC_SEL_11_REG_CLR               (*(volatile unsigned *) 0x10E400DCU)
#define rSW_TOP_FUNC_SEL_12_REG_SET               (*(volatile unsigned *) 0x10E400E0U)
#define rSW_TOP_FUNC_SEL_12_REG_CLR               (*(volatile unsigned *) 0x10E400E4U)
#define rSW_TOP_FUNC_SEL_13_REG_SET               (*(volatile unsigned *) 0x10E400E8U)
#define rSW_TOP_FUNC_SEL_13_REG_CLR               (*(volatile unsigned *) 0x10E400ECU)
#define rSW_TOP_FUNC_SEL_14_REG_SET               (*(volatile unsigned *) 0x10E400F0U)
#define rSW_TOP_FUNC_SEL_14_REG_CLR               (*(volatile unsigned *) 0x10E400F4U)
#define rSW_TOP_FUNC_SEL_15_REG_SET               (*(volatile unsigned *) 0x10E400F8U)
#define rSW_TOP_FUNC_SEL_15_REG_CLR               (*(volatile unsigned *) 0x10E400FCU)
#define rSW_TOP_FUNC_SEL_16_REG_SET               (*(volatile unsigned *) 0x10E40100U)
#define rSW_TOP_FUNC_SEL_16_REG_CLR               (*(volatile unsigned *) 0x10E40104U)
#define rSW_TOP_FUNC_SEL_17_REG_SET               (*(volatile unsigned *) 0x10E40108U)
#define rSW_TOP_FUNC_SEL_17_REG_CLR               (*(volatile unsigned *) 0x10E4010CU)
#define rSW_TOP_FUNC_SEL_18_REG_SET               (*(volatile unsigned *) 0x10E40110U)
#define rSW_TOP_FUNC_SEL_18_REG_CLR               (*(volatile unsigned *) 0x10E40114U)
#define rSW_TOP_FUNC_SEL_19_REG_SET               (*(volatile unsigned *) 0x10E40118U)
#define rSW_TOP_FUNC_SEL_19_REG_CLR               (*(volatile unsigned *) 0x10E4011CU)
#define rSW_TOP_FUNC_SEL_20_REG_SET               (*(volatile unsigned *) 0x10E40120U)
#define rSW_TOP_FUNC_SEL_20_REG_CLR               (*(volatile unsigned *) 0x10E40124U)
#define rSW_TOP_FUNC_SEL_21_REG_SET               (*(volatile unsigned *) 0x10E40128U)
#define rSW_TOP_FUNC_SEL_21_REG_CLR               (*(volatile unsigned *) 0x10E4012CU)
#define rSW_TOP_FUNC_SEL_22_REG_SET               (*(volatile unsigned *) 0x10E40130U)
#define rSW_TOP_FUNC_SEL_22_REG_CLR               (*(volatile unsigned *) 0x10E40134U)
#define rSW_TOP_FUNC_SEL_23_REG_SET               (*(volatile unsigned *) 0x10E40138U)
#define rSW_TOP_FUNC_SEL_23_REG_CLR               (*(volatile unsigned *) 0x10E4013CU)
#define rSW_TOP_FUNC_SEL_24_REG_SET               (*(volatile unsigned *) 0x10E40140U)
#define rSW_TOP_FUNC_SEL_24_REG_CLR               (*(volatile unsigned *) 0x10E40144U)
#define rSW_TOP_PULL_EN_0_REG_SET                 (*(volatile unsigned *) 0x10E40180U)
#define rSW_TOP_PULL_EN_0_REG_CLR                 (*(volatile unsigned *) 0x10E40184U)
#define rSW_TOP_PULL_EN_1_REG_SET                 (*(volatile unsigned *) 0x10E40188U)
#define rSW_TOP_PULL_EN_1_REG_CLR                 (*(volatile unsigned *) 0x10E4018CU)
#define rSW_TOP_PULL_EN_2_REG_SET                 (*(volatile unsigned *) 0x10E40190U)
#define rSW_TOP_PULL_EN_2_REG_CLR                 (*(volatile unsigned *) 0x10E40194U)
#define rSW_TOP_PULL_EN_3_REG_SET                 (*(volatile unsigned *) 0x10E40198U)
#define rSW_TOP_PULL_EN_3_REG_CLR                 (*(volatile unsigned *) 0x10E4019CU)
#define rSW_TOP_PULL_EN_4_REG_SET                 (*(volatile unsigned *) 0x10E401A0U)
#define rSW_TOP_PULL_EN_4_REG_CLR                 (*(volatile unsigned *) 0x10E401A4U)
#define rSW_TOP_PULL_EN_5_REG_SET                 (*(volatile unsigned *) 0x10E401A8U)
#define rSW_TOP_PULL_EN_5_REG_CLR                 (*(volatile unsigned *) 0x10E401ACU)
#define rSW_TOP_PULL_EN_6_REG_SET                 (*(volatile unsigned *) 0x10E401B0U)
#define rSW_TOP_PULL_EN_6_REG_CLR                 (*(volatile unsigned *) 0x10E401B4U)
#define rSW_TOP_PULL_EN_7_REG_SET                 (*(volatile unsigned *) 0x10E401B8U)
#define rSW_TOP_PULL_EN_7_REG_CLR                 (*(volatile unsigned *) 0x10E401BCU)
#define rSW_TOP_PULL_EN_8_REG_SET                 (*(volatile unsigned *) 0x10E401C0U)
#define rSW_TOP_PULL_EN_8_REG_CLR                 (*(volatile unsigned *) 0x10E401C4U)
#define rSW_TOP_PULL_EN_9_REG_SET                 (*(volatile unsigned *) 0x10E401C8U)
#define rSW_TOP_PULL_EN_9_REG_CLR                 (*(volatile unsigned *) 0x10E401CCU)
#define rSW_TOP_PULL_EN_10_REG_SET                (*(volatile unsigned *) 0x10E40200U)
#define rSW_TOP_PULL_EN_10_REG_CLR                (*(volatile unsigned *) 0x10E40204U)
#define rSW_TOP_PULL_EN_11_REG_SET                (*(volatile unsigned *) 0x10E40250U)
#define rSW_TOP_PULL_EN_11_REG_CLR                (*(volatile unsigned *) 0x10E40254U)
#define rSW_TOP_PULL_EN_12_REG_SET                (*(volatile unsigned *) 0x10E40258U)
#define rSW_TOP_PULL_EN_12_REG_CLR                (*(volatile unsigned *) 0x10E4025CU)
#define rSW_TOP_PULL_EN_13_REG_SET                (*(volatile unsigned *) 0x10E40260U)
#define rSW_TOP_PULL_EN_13_REG_CLR                (*(volatile unsigned *) 0x10E40264U)
#define rSW_TOP_PULL_EN_14_REG_SET                (*(volatile unsigned *) 0x10E40268U)
#define rSW_TOP_PULL_EN_14_REG_CLR                (*(volatile unsigned *) 0x10E4026CU)
#define rSW_TOP_PULL_EN_15_REG_SET                (*(volatile unsigned *) 0x10E40270U)
#define rSW_TOP_PULL_EN_15_REG_CLR                (*(volatile unsigned *) 0x10E40274U)
#define rSW_TOP_PULL_EN_16_REG_SET                (*(volatile unsigned *) 0x10E40278U)
#define rSW_TOP_PULL_EN_16_REG_CLR                (*(volatile unsigned *) 0x10E4027CU)
#define rSW_TOP_PULL_EN_17_REG_SET                (*(volatile unsigned *) 0x10E40280U)
#define rSW_TOP_PULL_EN_17_REG_CLR                (*(volatile unsigned *) 0x10E40284U)
#define rSW_TOP_STRENGTH_CNTL_0_REG_SET           (*(volatile unsigned *) 0x10E40300U)
#define rSW_TOP_STRENGTH_CNTL_0_REG_CLR           (*(volatile unsigned *) 0x10E40304U)
#define rSW_TOP_STRENGTH_CNTL_1_REG_SET           (*(volatile unsigned *) 0x10E40308U)
#define rSW_TOP_STRENGTH_CNTL_1_REG_CLR           (*(volatile unsigned *) 0x10E4030CU)
#define rSW_TOP_STRENGTH_CNTL_2_REG_SET           (*(volatile unsigned *) 0x10E40310U)
#define rSW_TOP_STRENGTH_CNTL_2_REG_CLR           (*(volatile unsigned *) 0x10E40314U)
#define rSW_TOP_STRENGTH_CNTL_3_REG_SET           (*(volatile unsigned *) 0x10E40318U)
#define rSW_TOP_STRENGTH_CNTL_3_REG_CLR           (*(volatile unsigned *) 0x10E4031CU)
#define rSW_TOP_STRENGTH_CNTL_4_REG_SET           (*(volatile unsigned *) 0x10E40320U)
#define rSW_TOP_STRENGTH_CNTL_4_REG_CLR           (*(volatile unsigned *) 0x10E40324U)
#define rSW_TOP_STRENGTH_CNTL_5_REG_SET           (*(volatile unsigned *) 0x10E40328U)
#define rSW_TOP_STRENGTH_CNTL_5_REG_CLR           (*(volatile unsigned *) 0x10E4032CU)
#define rSW_TOP_STRENGTH_CNTL_6_REG_SET           (*(volatile unsigned *) 0x10E40330U)
#define rSW_TOP_STRENGTH_CNTL_6_REG_CLR           (*(volatile unsigned *) 0x10E40334U)
#define rSW_TOP_STRENGTH_CNTL_7_REG_SET           (*(volatile unsigned *) 0x10E40338U)
#define rSW_TOP_STRENGTH_CNTL_7_REG_CLR           (*(volatile unsigned *) 0x10E4033CU)
#define rSW_TOP_STRENGTH_CNTL_8_REG_SET           (*(volatile unsigned *) 0x10E40340U)
#define rSW_TOP_STRENGTH_CNTL_8_REG_CLR           (*(volatile unsigned *) 0x10E40344U)
#define rSW_TOP_STRENGTH_CNTL_9_REG_SET           (*(volatile unsigned *) 0x10E40348U)
#define rSW_TOP_STRENGTH_CNTL_9_REG_CLR           (*(volatile unsigned *) 0x10E4034CU)
#define rSW_TOP_STRENGTH_CNTL_10_REG_SET          (*(volatile unsigned *) 0x10E40350U)
#define rSW_TOP_STRENGTH_CNTL_10_REG_CLR          (*(volatile unsigned *) 0x10E40354U)
#define rSW_TOP_STRENGTH_CNTL_11_REG_SET          (*(volatile unsigned *) 0x10E40358U)
#define rSW_TOP_STRENGTH_CNTL_11_REG_CLR          (*(volatile unsigned *) 0x10E4035CU)
#define rSW_TOP_STRENGTH_CNTL_12_REG_SET          (*(volatile unsigned *) 0x10E40360U)
#define rSW_TOP_STRENGTH_CNTL_12_REG_CLR          (*(volatile unsigned *) 0x10E40364U)
#define rSW_TOP_STRENGTH_CNTL_13_REG_SET          (*(volatile unsigned *) 0x10E40368U)
#define rSW_TOP_STRENGTH_CNTL_13_REG_CLR          (*(volatile unsigned *) 0x10E4036CU)
#define rSW_TOP_STRENGTH_CNTL_14_REG_SET          (*(volatile unsigned *) 0x10E40378U)
#define rSW_TOP_STRENGTH_CNTL_14_REG_CLR          (*(volatile unsigned *) 0x10E4037CU)
#define rSW_TOP_STRENGTH_CNTL_15_REG_SET          (*(volatile unsigned *) 0x10E40380U)
#define rSW_TOP_STRENGTH_CNTL_15_REG_CLR          (*(volatile unsigned *) 0x10E40384U)
#define rSW_TOP_AD_CNTL_0_REG_SET                 (*(volatile unsigned *) 0x10E40480U)
#define rSW_TOP_AD_CNTL_0_REG_CLR                 (*(volatile unsigned *) 0x10E40484U)
#endif // _SOC_FC__IOCTOP 

